
    range_quantification = range(i,1) : range(i,2);
    green_length = length(green);   
    %% calibration of movement      
    if switch_photometry_to_movement == 1   
        %% preprocessing of position data
        x_all = [];  
        y_all = [];    
        low_confidence_area_all = [];
        for k = 1 : length(x_index)
            x = deeplabcut_table(:, x_index(k)).*scale_xy;
            y = deeplabcut_table(:, y_index(k)).*scale_xy;
            xy_confidence = deeplabcut_table(:, xy_confidence_index(k));            
            if switch_xy_frame_calibration == 1              
                [x, y, xy_confidence, video_intensity_binary_calibrated] = ...
                    fun_video_stimulation_calibration(x, y, xy_confidence, video_intensity, video_intensity_threshold_SD, stimulation, video_stimulation_calibration_range, video_stimulation_shift_threshold, video_stimulation_calibration_reference); 
                if abs(length(x)-length(green)) > error_tolerance_all 
                    disp('warning xy calibration failed');
                    disp(strcat("length(x)-length(green)= ", string(length(x)-length(green))));
                    % return;
                end
            end

            if switch_xy_confidence_filter == 1 
                x = fun_remove_false_detection(x, xy_confidence, xy_confidence_threshold, xy_reference_n);
                y = fun_remove_false_detection(y, xy_confidence, xy_confidence_threshold, xy_reference_n);
                low_confidence_area = xy_confidence < xy_confidence_threshold;
            end

            if switch_xy_smooth_frequency == 1
                x = lowpass(x, xy_lowpass_filter_frequency, pulse_frequency, 'Steepness', 0.999999);
                y = lowpass(y, xy_lowpass_filter_frequency, pulse_frequency, 'Steepness', 0.999999);
            end 
            if switch_xy_smooth_average_mean == 1
                x = fun_smooth(x, xy_smooth_window, xy_smooth_iteration); 
                y = fun_smooth(y, xy_smooth_window, xy_smooth_iteration);
            end
            x_all = [x_all, x];
            y_all = [y_all, y];
            if k == 1
                low_confidence_area_all =  low_confidence_area;
            else
                low_confidence_area_all = low_confidence_area_all + low_confidence_area;
            end
        end
        low_confidence_area_all = low_confidence_area_all(range_quantification);
        
        %% preprocessing of head orientation data        
        x_head_orientation_all = [];
        y_head_orientation_all = [];    
        low_confidence_area_head_orientation_all = [];
        for k = 1 : length(x_head_orientation_index)
            x_head_orientation = deeplabcut_table(:, x_head_orientation_index(k));
            y_head_orientation = deeplabcut_table(:, y_head_orientation_index(k));
            xy_head_orientation_confidence = deeplabcut_table(:, xy_head_orientation_confidence_index(k));            
            if switch_xy_frame_calibration == 1              
                [x_head_orientation, y_head_orientation, xy_head_orientation_confidence, ~] = ...
                    fun_video_stimulation_calibration(x_head_orientation, y_head_orientation, xy_head_orientation_confidence, video_intensity, video_intensity_threshold_SD, stimulation, video_stimulation_calibration_range, video_stimulation_shift_threshold, video_stimulation_calibration_reference); 
                if abs(length(x_head_orientation)-length(green)) > error_tolerance_all 
                    disp('warning xy calibration failed');
                    disp(strcat("length(x)-length(green)= ", string(length(x_head_orientation)-length(green))));          
                end
            end

            if switch_xy_confidence_filter == 1 
                x_head_orientation = fun_remove_false_detection(x_head_orientation, xy_head_orientation_confidence, xy_confidence_threshold, xy_reference_n);
                y_head_orientation = fun_remove_false_detection(y_head_orientation, xy_head_orientation_confidence, xy_confidence_threshold, xy_reference_n);
                low_confidence_area_for_head_orientation = xy_head_orientation_confidence < xy_confidence_threshold;                
            end

            if switch_xy_smooth_frequency == 1
                x_head_orientation = lowpass(x_head_orientation, xy_lowpass_filter_frequency, pulse_frequency, 'Steepness', 0.999999); 
                y_head_orientation = lowpass(y_head_orientation, xy_lowpass_filter_frequency, pulse_frequency, 'Steepness', 0.999999); 
            end 
            if switch_xy_smooth_average_mean == 1
                x_head_orientation = fun_smooth(x_head_orientation, xy_smooth_window, xy_smooth_iteration); 
                y_head_orientation = fun_smooth(y_head_orientation, xy_smooth_window, xy_smooth_iteration);
            end
            x_head_orientation_all = [x_head_orientation_all, x_head_orientation];
            y_head_orientation_all = [y_head_orientation_all, y_head_orientation];
            if k == 1
                low_confidence_area_head_orientation_all =  low_confidence_area_for_head_orientation;
            else
                low_confidence_area_head_orientation_all = low_confidence_area_head_orientation_all + low_confidence_area_for_head_orientation;
            end
        end 
        low_confidence_area_head_orientation_all = low_confidence_area_head_orientation_all(range_quantification);
                         
        % calculate head angle    
            [angular_velocity_projection, angular_velocity_rejection, velocity_angle] = fun_velocity_component...
                (mean(x_all,2), mean(y_all,2), x_head_orientation_all(:,1), y_head_orientation_all(:,1), x_head_orientation_all(:,2), y_head_orientation_all(:,2), x_head_orientation_all(:,3), y_head_orientation_all(:,3));
            angular_velocity_projection = angular_velocity_projection(range_quantification);            
            velocity_angle = velocity_angle(range_quantification);
            angular_velocity_rejection = angular_velocity_rejection(range_quantification);
        
        velocity = fun_deeplabcut_velocity(mean(x_all,2), mean(y_all,2));      
    end

    %% filter photometry data
    green_baseline = lowpass(green, photometry_baseline_lowpass_filter_frequency, pulse_frequency, 'Steepness', 0.999999);
    red_baseline = lowpass(red, photometry_baseline_lowpass_filter_frequency, pulse_frequency, 'Steepness', 0.999999);

    green_change = green - green_baseline;    
    green_change_relative = green_change ./ green_baseline; 
    red_change = red - red_baseline;    
    red_change_relative = red_change ./ red_baseline;
   
    green_change_relative = green_change_relative(range_quantification);
    red_change_relative = red_change_relative(range_quantification);
    green_baseline = green_baseline(range_quantification);
    red_baseline = red_baseline(range_quantification);   
    green = green(range_quantification);
    red = red(range_quantification);

    %% generate further analysis of photometry data  
    result.green_raw(:,i)={green};
    result.red_raw(:,i)={red};
    result.green_baseline(:,i)={green_baseline};
    result.red_baseline(:,i)={red_baseline};
    result.green_change_relatve(:,i)={green_change_relative};
    result.red_change_relatve(:,i)={red_change_relative};    
    green_change_relative_moving_std = movstd(green_change_relative, std_window);    
    green_change_SD = std(green_change);
    green_change_relative_SD = std(green_change_relative);    
    red_change_relative_moving_std = movstd(red_change_relative, std_window);   
    red_change_SD = std(red_change);
    red_change_relative_SD = std(red_change_relative);
    

    result.green_change_SD(:, i) = green_change_SD;
    result.green_change_relative_SD(:, i) = green_change_relative_SD;
    result.green_change_relative_moving_std_mean(:, i) = mean(green_change_relative_moving_std);

    result.red_change_SD(:, i) = red_change_SD;
    result.red_change_relative_SD(:, i) = red_change_relative_SD;
    result.red_change_relative_moving_std_mean(:, i) = mean(red_change_relative_moving_std);
  
        
    %% movement analysis
    if switch_photometry_to_movement == 1   
        movement_length = length(velocity);  
        velocity = velocity(range_quantification);                     
        velocity_moving_std = movstd(velocity, std_window);  
        result.velocity(1,i) = {velocity};
        result.velocity_angle(1,i)  ={velocity_angle};
    end
    
    if switch_photometry_to_stimulation == 1
        result.stimulation(1,i) = {stimulation};
    end
    
    
    close('all')  



