clear;
%% set parameter
file_list = 'D:\data\photometry\test_general code\list_grabACh_rGrabDA_test.xlsx'; 
output_result_file = 'D:\data\photometry\test_general code\test_general code.mat'; 


%% set output format
alignment_points_before = 500; 
alignment_points_after = 500; 
std_window = [8, 8]; 

% preprocess of the raw data
photometry_baseline_lowpass_filter_frequency = 0.01; 
    
switch_photometry_to_movement = 1;    
 % select the analysis
    % xy
    x_index = [2]; 
    y_index = [3];
    xy_confidence_index = [4]; 
    x_head_orientation_index = [2,5,8]; 
    y_head_orientation_index = [3,6,9];
    xy_head_orientation_confidence_index = [4,7,10]; 
    scale_xy = 0.97;    

    switch_xy_frame_calibration = 1;        
        video_intensity_threshold_SD = 4; 
        video_stimulation_calibration_reference = 1; 
        video_stimulation_calibration_range = 20;  
        video_stimulation_shift_threshold = 0; 
        error_tolerance_all = 20; 
    switch_xy_confidence_filter = 1; 
        xy_confidence_threshold = 0.99; 
        xy_reference_n = 50; 
    switch_xy_smooth_average_mean = 1; 
        xy_smooth_window = 3;
        xy_smooth_iteration = 1; 
    switch_xy_smooth_frequency = 0; 
        xy_lowpass_filter_frequency = 2; 

 switch_photometry_to_stimulation = 1;  

%% start the analysis
%read the list
tic;
[range, TEXT, list] = xlsread(file_list);  
list = string(list); 
list_photometry = list(:, 1)'; 
[list_check_photometry] = fun_file_checkexistance(list_photometry); 
if list_check_photometry > 0 
   return;
end 
if switch_photometry_to_movement == 1  
    list_deeplabcut_file = list(:, 2); 
    [list_check_video_file] = fun_file_checkexistance(list_deeplabcut_file); 
    if list_check_video_file > 0 
        return;
    end 
end

if switch_xy_frame_calibration == 1  
    list_video_intensity_file = list(:, 5);   
    [list_check_video_intensity_file] = fun_file_checkexistance(list_video_intensity_file); 
    if list_check_video_intensity_file > 0 
        return;
    end 
end

%% start analysis
  z_group_index = []; 
  z_group_std_green = []; 
  z_group_std_red = []; 

for i = 1 : length(list_photometry)
    tic;  
    disp(strcat("processing ", string(i), "/", string(length(list_photometry))));
    display(list_photometry(i));
    load(list_photometry(i));    
    if switch_photometry_to_movement == 1       
        deeplabcut_table = readmatrix(list_deeplabcut_file(i));
        if switch_xy_frame_calibration == 1 
                load(list(i,5)); 
        end
    end
    %% photometry analysis and extract stimulation timepoint
    result.parameters.range(:,i) = {range(i, :)};    
    pulse_frequency = data.parameters.pulse_frequency; 
    green_raw = data.green_raw;
    green_marker_raw = data.green_marker_raw;
    G_exposure_n = data.parameters.G_exposure * data.parameters.background_frequency;
    G_baseline_n = data.parameters.G_baseline * data.parameters.background_frequency;
    G_afterLED_n = data.parameters.G_afterLED * data.parameters.background_frequency;
    G_average_n = data.parameters.G_average * data.parameters.background_frequency;
    G_subtraction_check = data.parameters.G_subtraction_check;
    red_raw = data.red_raw;
    red_marker_raw = data.red_marker_raw;
    R_exposure_n = data.parameters.R_exposure * data.parameters.background_frequency;
    R_baseline_n = data.parameters.R_baseline * data.parameters.background_frequency;
    R_afterLED_n = data.parameters.R_afterLED * data.parameters.background_frequency;
    R_average_n = data.parameters.R_average * data.parameters.background_frequency;
    R_subtraction_check = data.parameters.R_subtraction_check;     
    analyze_index = 1;    
  
    
    %% analyze photometry data
    if switch_photometry_to_stimulation == 1
        stimulation_marker_raw = data.stimulation_marker_raw;  
        [green, red, stimulation, ~, ~] = fun_raw_analysis_stimulation... 
        (green_raw, green_marker_raw, G_exposure_n, G_baseline_n, G_afterLED_n, G_average_n, G_subtraction_check,...
            red_raw, red_marker_raw, R_exposure_n, R_baseline_n, R_afterLED_n, R_average_n, R_subtraction_check,...
                analyze_index, stimulation_marker_raw); 
        
    else
        green = data.green;
        red = data.red;
    end 
    
    W_photometry_analysis;
    
    disp 'done'
    toc; 
    disp ' '
end

    save(output_result_file, 'result', '-v7.3');
disp('all done')

