function [output_projection, output_rejection, output_angle] = fun_velocity_component...
    (input_x, input_y, input_nose_x, input_nose_y, input_ear_x1, input_ear_y1,  input_ear_x2, input_ear_y2)

% for generating projections of acceleration on the direction of head

%% generate velocity as a vector
% velocity_x = zeros(length(input_x),1);
% velocity_y = zeros(length(input_y),1);
% velocity_x(2:length(input_x)-1,1) = (input_x(3:end) - input_x(1:end-2))./2;
% velocity_y(2:length(input_y)-1,1) = (input_y(3:end) - input_y(1:end-2))./2;
% velocity_complex = complex(velocity_y, velocity_x); % generate acceleration vector x and y are swapped so that left turn is positive
% velocity_direction = angle(velocity_complex); 
% % for i = 1 : length(velocity_direction) % so that the theta is between 0 and 2pi
% %    if velocity_direction(i) < 0
% %         velocity_direction(i) = velocity_direction(i) + 2*pi;
% %    end
% % end
% 
% 
% %% generate head direction
% head_center_x = (input_ear_x1 + input_ear_x2)./2;
% head_center_y = (input_ear_y1 + input_ear_y2)./2;
% head_center_x(2:end) = (head_center_x(1:end-1) + head_center_x(2:end))./2; % find the head angle at the timepoint of velocity
% head_center_y(2:end) = (head_center_y(1:end-1) + head_center_y(2:end))./2; % find the head angle at the timepoint of velocity
% 
% head_complex = complex((input_nose_y-head_center_y), (input_nose_x-head_center_x));
% head_direction = angle(head_complex); 
% % for i = 1 : length(head_direction)
% %     if head_direction(i) < 0
% %            head_direction(i) = head_direction(i) + 2*pi;
% %     end
% % end



%% generate velocity as a vector
velocity_x = zeros(length(input_x),1);
velocity_y = zeros(length(input_y),1);
velocity_x(2:length(input_x),1) = (input_x(2:end) - input_x(1:end-1));
velocity_y(2:length(input_y),1) = (input_y(2:end) - input_y(1:end-1));
velocity_complex = complex(velocity_y, velocity_x); % generate acceleration vector x and y are swapped so that left turn is positive
velocity_direction = angle(velocity_complex); 


%% generate head direction
head_center_x_temp = (input_ear_x1 + input_ear_x2)./2;
head_center_y_temp = (input_ear_y1 + input_ear_y2)./2;
head_center_x = zeros(length(input_ear_x1),1);
head_center_y = zeros(length(input_ear_y1),1);
head_center_x(2:end) = (head_center_x_temp(2:end) + head_center_x_temp(1:end-1))./2;
head_center_y(2:end) = (head_center_y_temp(2:end) + head_center_y_temp(1:end-1))./2;

nose_x = zeros(length(input_nose_x),1);
nose_y = zeros(length(input_nose_y),1);
nose_x(2:end) = (input_nose_x(2:end) + input_nose_x(1:end-1))./2;
nose_y(2:end) = (input_nose_y(2:end) + input_nose_y(1:end-1))./2;

head_complex = complex((nose_y-head_center_y), (nose_x-head_center_x));
head_direction = angle(head_complex); 


%% generat output

output_angle = velocity_direction - head_direction;
output_projection = abs(velocity_complex).*cos(output_angle);
output_rejection = abs(velocity_complex).*sin(output_angle);

output_angle = output_angle.* 180 ./pi; % in degree

end

