function [output_x, output_y, output_xy_confidence, output_video_intensity_binary] = ...
    fun_video_stimulation_calibration(input_x, input_y, input_xy_confidence, input_video_intensity, input_video_intensity_threshold_SD, input_stimulation, calibration_range, shift_threshold, calibration_reference)
    
% to add or remove frames in the movement data to match with the photometry
   output_x = input_x;
   output_y = input_y;
   output_xy_confidence = input_xy_confidence;   
   output_video_intensity_binary = input_video_intensity > input_video_intensity_threshold_SD * std(input_video_intensity) + mean(input_video_intensity);
   
  
%    stimulation_end_position = fun_find_stimulation_end_position(input_stimulation);   
%     position_temp = strfind(output_video_intensity_derivative_binary(stimulation_end_position(1)-calibration_range:stimulation_end_position(1)+calibration_range)',[-1,0]);
%                 position = position_temp + stimulation_end_position(1)-calibration_range ; 
%                 stimulation_end_position(1)
%                 position_temp 
%                 position
%                 return
%    
%    
   
   
   if calibration_reference == 1 % calibrate to the start of the stimulation
       stimulation_start_position = fun_find_stimulation_start_position(input_stimulation);   
       for i = 1 : length(stimulation_start_position)         
            if isempty(strfind(output_video_intensity_binary(stimulation_start_position(i)-shift_threshold-1:stimulation_start_position(i)+shift_threshold)',[0,1]))                
                position_temp = strfind(output_video_intensity_binary(stimulation_start_position(i)-calibration_range:stimulation_start_position(i)+calibration_range)',[0,1]);
                position = position_temp + stimulation_start_position(i)-calibration_range;      
                if ~isempty(position)
                    if position < stimulation_start_position(i)
                            frame_to_add_x = zeros(stimulation_start_position(i)-position,1);
                            frame_to_add_y = zeros(stimulation_start_position(i)-position,1);
                            frame_to_add_xy_confidence = zeros(stimulation_start_position(i)-position,1);
                            frame_to_add_video_intensity_binary = zeros(stimulation_start_position(i)-position,1);
                            frame_to_add_x(1:stimulation_start_position(i)-position,1) = output_x(position-1);
                            frame_to_add_y(1:stimulation_start_position(i)-position,1) = output_y(position-1);
                            frame_to_add_xy_confidence(1:stimulation_start_position(i)-position,1) = output_xy_confidence(position-1);
                            frame_to_add_video_intensity_binary(1:stimulation_start_position(i)-position,1) = output_video_intensity_binary(position-1);
                            output_x = [output_x(1:position-1); frame_to_add_x; output_x(position:end)];
                            output_y = [output_y(1:position-1); frame_to_add_y; output_y(position:end)];
                            output_xy_confidence = [output_xy_confidence(1:position-1); frame_to_add_xy_confidence; output_xy_confidence(position:end)];
                            output_video_intensity_binary = [output_video_intensity_binary(1:position-1); frame_to_add_video_intensity_binary; output_video_intensity_binary(position:end)];
                            %disp(strcat(string(stimulation_start_position(i)), " calibrated by ", string(stimulation_start_position(i)-position)));                      
                    else
                            output_x = [output_x(1:stimulation_start_position(i)-1); output_x(position:end)];
                            output_y = [output_y(1:stimulation_start_position(i)-1); output_y(position:end)];
                            output_xy_confidence = [output_xy_confidence(1:stimulation_start_position(i)-1); output_xy_confidence(position:end)];
                            output_video_intensity_binary = [output_video_intensity_binary(1:stimulation_start_position(i)-1); output_video_intensity_binary(position:end)];
                            %disp(strcat(string(stimulation_start_position(i)), " calibrated by ", string(stimulation_start_position(i)-position)));                  
                    end
                else
                    disp(strcat(string(stimulation_start_position(i)), " calibration failed ")); 
                end
            end    
       end
   elseif calibration_reference == -1       
       stimulation_end_position = fun_find_stimulation_end_position(input_stimulation);   
       for i = 1 : length(stimulation_end_position)          
            if isempty(strfind(output_video_intensity_binary(stimulation_end_position(i)-shift_threshold : stimulation_end_position(i)+shift_threshold+1)',[1,0]))                
                position_temp = strfind(output_video_intensity_binary(stimulation_end_position(i)-calibration_range:stimulation_end_position(i)+calibration_range)',[1,0]);
                position = position_temp + stimulation_end_position(i)-calibration_range -1;   
                
               
                
                if ~isempty(position)
                    if position < stimulation_end_position(i)
                            frame_to_add_x = zeros(stimulation_end_position(i)-position,1);
                            frame_to_add_y = zeros(stimulation_end_position(i)-position,1);
                            frame_to_add_xy_confidence = zeros(stimulation_end_position(i)-position,1);
                            frame_to_add_video_intensity_binary = zeros(stimulation_end_position(i)-position,1);
                            frame_to_add_x(1:stimulation_end_position(i)-position,1) = output_x(position-1);
                            frame_to_add_y(1:stimulation_end_position(i)-position,1) = output_y(position-1);
                            frame_to_add_xy_confidence(1:stimulation_end_position(i)-position,1) = output_xy_confidence(position-1);
                            frame_to_add_video_intensity_binary(1:stimulation_end_position(i)-position,1) = output_video_intensity_binary(position-1);
                            output_x = [output_x(1:position-1); frame_to_add_x; output_x(position:end)];
                            output_y = [output_y(1:position-1); frame_to_add_y; output_y(position:end)];
                            output_xy_confidence = [output_xy_confidence(1:position-1); frame_to_add_xy_confidence; output_xy_confidence(position:end)];
                            output_video_intensity_binary = [output_video_intensity_binary(1:position-1); frame_to_add_video_intensity_binary; output_video_intensity_binary(position:end)];
                            %disp(strcat(string(stimulation_end_position(i)), " calibrated by ", string(stimulation_end_position(i)-position)));                      
                    else
                            output_x = [output_x(1:stimulation_end_position(i)-1); output_x(position:end)];
                            output_y = [output_y(1:stimulation_end_position(i)-1); output_y(position:end)];
                            output_xy_confidence = [output_xy_confidence(1:stimulation_end_position(i)-1); output_xy_confidence(position:end)];
                            output_video_intensity_binary = [output_video_intensity_binary(1:stimulation_end_position(i)-1); output_video_intensity_binary(position:end)];
                            %disp(strcat(string(stimulation_end_position(i)), " calibrated by ", string(stimulation_end_position(i)-position)));                  
                    end
                else
                    disp(strcat(string(stimulation_end_position(i)), " calibration failed ")); 
                end
            end    
       end

      

               
end

